<template>
  <div class="sw-gs-widget-product-variants">
    <SfLoader class="widget-loader" :loading="isLoading" v-if="isLoading"/>
    <template v-else>
      <div class="product-variants-container">
        <div v-if="mainVariantsProducts && mainVariantsProducts.length > 0"
             v-for="(product, index) in mainVariantsProducts"
             :key="'product-main-variants-item-'+ index"
             class="product-main-variants">
          <SwGsLayerProductCard :product="product"></SwGsLayerProductCard>
        </div>

        <!-- Variants -->
        <div v-if="productVariants && productVariants.length > 0" class="product-variants">
          <div class="product-variants-label">
            {{ $t('Variants') }}
          </div>

          <div class="product-variants-row product-variants-header">
            <div class="product-variants-col is-name">{{ $t('Name') }}</div>
            <div class="product-variants-col is-price">{{ $t('Euro') }}</div>
            <div class="product-variants-col is-stock">{{ $t('Available') }}</div>
            <div class="product-variants-col is-actions"></div>
          </div>

          <div v-for="(variant, index) in productVariants"
               :key="'product-variant-'+ index"
               class="product-variants-row">
            <!-- Name -->
            <div class="product-variants-col is-name">
              <div v-if="variant.options && variant.options.length > 0"
                   v-for="(option, index) in variant.options"
                   class="product-variants-value">
                <span class="value-text">{{ getTranslatedProperty(option, 'name') }}</span>
                <span v-if="index !== Object.keys(variant.options).length - 1" class="divider-element">-</span>
              </div>
              <div v-else class="product-variants-value">
                <span>{{ $t('n/a') }}</span>
              </div>
            </div>
            <!-- Price -->
            <div class="product-variants-col is-price">
              <VariantPrice :variant="variant"></VariantPrice>
            </div>
            <!-- Stock -->
            <div class="product-variants-col is-stock">
              <div v-if="variant.availableStock && variant.availableStock > 0" class="product-variants-value">
                {{ variant.availableStock }}
              </div>
              <div v-else class="product-variants-value">
                {{ $t('n/a') }}
              </div>
            </div>
            <!-- Actions -->
            <div class="product-variants-col is-actions">
              <SwGsLayerProductActions :product="variant" :detail-link="false"/>
            </div>
          </div>
        </div>
        <div v-else class="product-variants">
          {{ $t('This product does not have variants.') }}
        </div>
      </div>
    </template>
  </div>
</template>

<script lang="ts">
  import { ref, onMounted, watch } from "@vue/composition-api";
  import { SfLoader } from "@storefront-ui/vue";
  import { SfAccordion } from "@storefront-ui/vue";
  import SwGsAccordionItem from "../layer/SwGsAccordionItem.vue";
  import SwGsLayerProductActions from "../layer/SwGsLayerProductActions.vue";
  import SwGsLayerProductCard from "../layer/SwGsLayerProductCard.vue";
  import VariantPrice from "./product-variants/VariantPrice.vue";
  import { useProductVariants } from "../../logic/composables/widgets/useProductVariants";
  import { getTranslatedProperty } from "@shopware-pwa/helpers";

  export default {
    name: "SwGsProductVariants",
    components: {
      SfLoader,
      SfAccordion,
      SwGsAccordionItem,
      SwGsLayerProductActions,
      SwGsLayerProductCard,
      VariantPrice
    },
    props: {
      slotContext: {
        type: [Object, Array, String],
        default: null,
      },
    },
    setup(props, {}) {
      const product = ref(props.slotContext);

      const {
        loadProductVariants,
        loadMainVariantsProducts,
        productVariants,
        mainVariantsProducts
      } = useProductVariants(product.value);
      const isLoading = ref(false);

      onMounted(async () => {
        isLoading.value = true;
        await Promise.all([
          loadProductVariants(),
          loadMainVariantsProducts()
        ]);
        isLoading.value = false;
      })

      watch(product, (newProductValue) => {
        if (!newProductValue) return;
        loadProductVariants();
      });

      return {
        product,
        isLoading,
        productVariants,
        mainVariantsProducts,
        getTranslatedProperty
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .widget-loader {
    height: 50px;
  }

  .sw-gs-widget-product-variants {
    display: flex;
    flex-wrap: wrap;
    margin-left: calc(-1 * var(--spacer-xs));
    margin-right: calc(-1 * var(--spacer-xs));

    .product-main-variant {
      display: flex;
      width: 100%;
    }

    .product-variants-container {
      width: 100%;
    }

    .product-variants {
      padding: var(--spacer-xs);

      .product-variants-label {
        font-size: var(--font-size--sm);
        padding: 5px 0;
        margin-bottom: 5px;
        border-bottom: 2px solid var(--c-primary);
      }

      .product-variants-header {
        font-weight: 500;
      }

      .product-variants-row {
        font-size: var(--font-size--sm);
        display: flex;
        margin: 0 -5px 5px;
      }

      .product-variants-col {
        display: flex;
        flex-wrap: wrap;
        align-items: center;
        padding: 0 5px;
        overflow: hidden;

        &.is-name {
          width: 35%;
          max-width: 35%;
        }

        &.is-price {
          width: 23%;
          max-width: 23%;
          align-items: flex-start;
          justify-content: flex-end;
        }

        &.is-stock {
          width: 17%;
          max-width: 17%;
          align-items: flex-start;
          justify-content: flex-end;
        }

        &.is-actions {
          width: 25%;
          max-width: 25%;
          align-items: flex-start;
          justify-content: flex-end;
        }
      }

      .product-variants-value {
        display: flex;
        word-break: break-word;
        hyphens: auto;
        overflow: hidden;
        text-overflow: ellipsis;
        display: -webkit-box;
        -webkit-line-clamp: 2;
        line-clamp: 2; 
        -webkit-box-orient: vertical;

        .divider-element {
          padding: 0 3px;
        }
      }
    }

    ::v-deep {
      .sw-gs-layer-product-card-wrapper {
        width: 100%;
        flex: 0 0 50%;
        max-width: 50%;
      }
    }
  }

  .sf-loader {
    min-height: 70px; // space for loader
  }
</style>
